/*
 * MadMPI benchmark
 * Copyright (C) 2015 (see AUTHORS file)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 */


#include <stdlib.h>
#include "mpi_bench_generic.h"

extern const struct mpi_bench_s mpi_bench_coll_barrier;
extern const struct mpi_bench_s mpi_bench_coll_bcast;
extern const struct mpi_bench_s mpi_bench_coll_gather;
extern const struct mpi_bench_s mpi_bench_coll_allgather;
extern const struct mpi_bench_s mpi_bench_coll_allreduce;
extern const struct mpi_bench_s mpi_bench_coll_alltoall;
extern const struct mpi_bench_s mpi_bench_coll_ibcast;
extern const struct mpi_bench_s mpi_bench_coll_igather;
extern const struct mpi_bench_s mpi_bench_coll_iallgather;
extern const struct mpi_bench_s mpi_bench_coll_iallreduce;
extern const struct mpi_bench_s mpi_bench_coll_ialltoall;

int main(int argc, char**argv)
{
  struct mpi_bench_param_s params =
    {
      .start_len   = MIN_DEFAULT,
      .end_len     = MAX_DEFAULT,
      .multiplier  = MULT_DEFAULT,
      .increment   = INCR_DEFAULT,
      .iterations  = LOOPS_DEFAULT,
      .param       = PARAM_DEFAULT
    };

  mpi_bench_init(&argc, &argv, 0);
  mpi_bench_run(&mpi_bench_coll_barrier, &params);
  mpi_bench_run(&mpi_bench_coll_bcast, &params);
  mpi_bench_run(&mpi_bench_coll_gather, &params);
  mpi_bench_run(&mpi_bench_coll_allgather, &params);
  mpi_bench_run(&mpi_bench_coll_allreduce, &params);
  mpi_bench_run(&mpi_bench_coll_alltoall, &params);
  mpi_bench_run(&mpi_bench_coll_ibcast, &params);
  mpi_bench_run(&mpi_bench_coll_igather, &params);
  mpi_bench_run(&mpi_bench_coll_iallgather, &params);
  mpi_bench_run(&mpi_bench_coll_iallreduce, &params);
  mpi_bench_run(&mpi_bench_coll_ialltoall, &params);
  mpi_bench_finalize();
  exit(0);
}
